"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const uuid_1 = require("uuid");
const video_js_1 = __importDefault(require("video.js"));
require("video.js/dist/video-js.css");
const DEFAULT_CLASSNAME = "sldp-react-player";
const FallbackPlayer = ({ streamUrl, wrapperId = `sldp-react-player-${(0, uuid_1.v4)()}`, muted, width, height }) => {
    const [videoEl, setVideoEl] = (0, react_1.useState)();
    const [playerInst, setPlayerInst] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        if (videoEl) {
            if (!playerInst) {
                setPlayerInst((0, video_js_1.default)(videoEl, {
                    playsinline: true,
                    muted,
                    autoplay: true,
                    controls: false,
                    sources: streamUrl,
                    fluid: true
                }, function onPlayerReady() {
                    // do nothing
                }));
            }
            else {
                const isPlayerAlreadyPlaying = videoEl && videoEl.currentTime > 0 && !videoEl.paused && !videoEl.ended && videoEl.readyState > videoEl.HAVE_CURRENT_DATA;
                if (!isPlayerAlreadyPlaying) {
                    try {
                        playerInst.src(streamUrl);
                        fetch(streamUrl)
                            .then(response => response.blob())
                            .then(blob => {
                            playerInst.srcObject = blob;
                            return playerInst.play();
                        })
                            .then(_ => {
                            // do nothing
                        })
                            .catch(e => {
                            // do nothing
                        });
                    }
                    catch (ex) {
                        // do nothing
                    }
                }
            }
        }
        return () => {
            if (playerInst) {
                const isPlayerAlreadyPlaying = videoEl && videoEl.currentTime > 0 && !videoEl.paused && !videoEl.ended && videoEl.readyState > videoEl.HAVE_CURRENT_DATA;
                if (isPlayerAlreadyPlaying) {
                    try {
                        playerInst.pause();
                    }
                    catch (ex) {
                        // do nothing
                    }
                }
            }
        };
    }, [videoEl, streamUrl, playerInst, muted]);
    function onVideoError() {
        if (!videoEl)
            return;
        if (playerInst)
            playerInst.src(streamUrl);
    }
    (0, react_1.useEffect)(() => {
        if (videoEl) {
            // eslint-disable-next-line
            console.warn("FallbackPlayer error:", videoEl.error);
            videoEl.addEventListener('error', onVideoError);
        }
        return () => {
            if (videoEl) {
                videoEl.removeEventListener('error', onVideoError);
            }
        };
    }, [videoEl]);
    return react_1.default.createElement("div", { id: wrapperId, className: DEFAULT_CLASSNAME, style: { width, height } },
        react_1.default.createElement("video", { ref: (el) => setVideoEl(el), className: "video-js", width: "100%", height: "100%" }));
};
exports.default = FallbackPlayer;
