"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const StandardPlayer_1 = __importDefault(require("./StandardPlayer"));
const FallbackPlayer_1 = __importDefault(require("./FallbackPlayer"));
const Player = (props) => {
    const { streamUrl, muted = false, controls, width, height } = props;
    const sldpStreamUrl = (0, react_1.useMemo)(() => streamUrl.split(";")[0].trim(), [streamUrl]);
    const fallbackStreamUrl = (0, react_1.useMemo)(() => {
        const tmp = streamUrl.split(";");
        if (tmp.length > 1) {
            return tmp[1].trim();
        }
        return tmp[0].trim();
    }, [streamUrl]);
    const [deviceRecognized, setDeviceRecognized] = (0, react_1.useState)(false);
    const [isIPhone, setIsIPhone] = (0, react_1.useState)(true);
    (0, react_1.useEffect)(() => {
        if (!window.navigator) {
            return;
        }
        // const mobileDetect = new MobileDetect(window.navigator.userAgent);
        // setIsIPhone(mobileDetect.is('iPhone'));
        setDeviceRecognized(true);
    }, []);
    if (!deviceRecognized)
        return null;
    if (isIPhone) {
        return react_1.default.createElement(FallbackPlayer_1.default, { wrapperId: props.wrapperId, muted: muted, streamUrl: fallbackStreamUrl, width: width, height: height });
    }
    return react_1.default.createElement(StandardPlayer_1.default, Object.assign({}, props, { streamUrl: sldpStreamUrl }));
};
exports.default = Player;
